'*************************************************
'*     IMPULSE RESPONSE FUNCTIONS	*
'*************************************************
'wfselect DATA\INPUT

subroutine MA_STYLE_TB_EB(string %enddate)

range 1975q1 2018q4
coef(1000) C2
coef(1000) CS_tb
coef(1000) CS_gb
coef(1000) CS2

!horz = 6    '  6 8 12 ' anticipation horizon 
!horz_irf = 12 'irf horizon
!reps =1000
!INC = 0

smpl @all

'set variables
%VAR = "d_gdp" 
%diff  =  "d_gdp"

%startdate =     "1981q1"   
'%enddate =  "2012q4"   '  "2012q4"    "2007q4" 

%KIND = "t g"   '    "t g"

smpl %startdate %enddate

'!INC - # of endogeneous variables
FOR %V {%VAR}
	!INC = !INC  + 1
NEXT
!m=1
'IF !INC>9 then 
'		!m=9
'else !m = !INC
'ENDIF
'!m=0
'IF !horz+1>9 then 
'		!m=9
'else !m = !horz+1
'ENDIF

FOR %K {%KIND}
'create storage matrix
			FOR %V {%VAR} 
				matrix(!horz_irf,!reps) M_{%V}_{%K}=NA
			NEXT 

SMPL @ALL

FOR %V {%VAR}
	series  ser_{%V} = {%V}
NEXT

'generating the series
GENR TOT_SU_S = TOT_SU
GENR TOT_SA_S = TOT_SA
GENR TB_S = TB
GENR GB_S = GB

FOR !i = 1 TO !horz
		GENR TOT_SA{!i}_S = TOT_SA{!i}
NEXT

'# of non zero observations
'smpl if tot <> 0
'scalar a = @obs(tot)

FOR %V {%VAR} 
	
	'set the systems
	%sys="sys_bs_"+%V
	%sys2="sys_bs_"+%V+"2"
	%sys1="sys_style"
	
	'delete {%sys}*
	system {%sys}
		
	{%sys}.append ser_{%V}  =  C(1) + C(2)*TOT_SU_S*TB_S + C(3)*TOT_SU_S(-1)*TB_S(-1) + C(4)*TOT_SU_S(-2)*TB_S(-2) + C(5)*TOT_SU_S(-3)*TB_S(-3) + C(6)*TOT_SU_S(-4)*TB_S(-4) + C(7)*TOT_SU_S(-5)*TB_S(-5) + C(8)*TOT_SU_S(-6)*TB_S(-6) + C(10)*TOT_SU_S*GB_S + C(11)*TOT_SU_S(-1)*GB_S(-1) + C(12)*TOT_SU_S(-2)*GB_S(-2) + C(13)*TOT_SU_S(-3)*GB_S(-3) + C(14)*TOT_SU_S(-4)*GB_S(-4) + C(15)*TOT_SU_S(-5)*GB_S(-5) + C(16)*TOT_SU_S(-6)*GB_S(-6) + C(18)*TOT_SA_S*TB_S + C(19)*TOT_SA_S(-1)*TB_S(-1) + C(20)*TOT_SA_S(-2)*TB_S(-2) + C(21)*TOT_SA_S(-3)*TB_S(-3) + C(22)*TOT_SA_S(-4)*TB_S(-4) + C(23)*TOT_SA_S(-5)*TB_S(-5) + C(24)*TOT_SA_S(-6)*TB_S(-6) + C(26)*TOT_SA1_S*TB_S + C(27)*TOT_SA2_S*TB_S + C(28)*TOT_SA3_S*TB_S + C(29)*TOT_SA4_S*TB_S + C(30)*TOT_SA5_S*TB_S + C(31)*TOT_SA6_S*TB_S + C(34)*TOT_SA_S*GB_S + C(35)*TOT_SA_S(-1)*GB_S(-1) + C(36)*TOT_SA_S(-2)*GB_S(-2) + C(37)*TOT_SA_S(-3)*GB_S(-3) + C(38)*TOT_SA_S(-4)*GB_S(-4) + C(39)*TOT_SA_S(-5)*GB_S(-5) + C(40)*TOT_SA_S(-6)*GB_S(-6) + C(42)*TOT_SA1_S*GB_S + C(43)*TOT_SA2_S*GB_S + C(44)*TOT_SA3_S*GB_S + C(45)*TOT_SA4_S*GB_S + C(46)*TOT_SA5_S*GB_S + C(47)*TOT_SA6_S*GB_S 

	'{%sys}.append ser_{%V}  =  C(1)*TOT_SU_S*TB_S + C(2)*TOT_SU_S(-1)*TB_S(-1) + C(3)*TOT_SU_S(-2)*TB_S(-2) + C(4)*TOT_SU_S(-3)*TB_S(-3) + C(5)*TOT_SU_S(-4)*TB_S(-4) + C(6)*TOT_SU_S(-5)*TB_S(-5) + C(7)*TOT_SU_S(-6)*TB_S(-6) +  C(8)*TOT_SU_S(-7)*TB_S(-7) + C(9)*TOT_SU_S(-8)*TB_S(-8) + C(10)*TOT_SU_S(-9)*TB_S(-9) + C(11)*TOT_SU_S(-10)*TB_S(-10) + C(12)*TOT_SU_S(-11)*TB_S(-11) + C(13)*TOT_SU_S(-12)*TB_S(-12) + C(14)*TOT_SU_S*GB_S + C(15)*TOT_SU_S(-1)*GB_S(-1) + C(16)*TOT_SU_S(-2)*GB_S(-2) + C(17)*TOT_SU_S(-3)*GB_S(-3) + C(18)*TOT_SU_S(-4)*GB_S(-4) + C(19)*TOT_SU_S(-5)*GB_S(-5) + C(20)*TOT_SU_S(-6)*GB_S(-6) + C(21)*TOT_SU_S(-7)*GB_S(-7) + C(22)*TOT_SU_S(-8)*GB_S(-8) + C(23)*TOT_SU_S(-9)*GB_S(-9) + C(24)*TOT_SU_S(-10)*GB_S(-10) + C(25)*TOT_SU_S(-11)*GB_S(-11) + C(26)*TOT_SU_S(-12)*GB_S(-12) + C(27)*TOT_SA_S*TB_S + C(28)*TOT_SA_S(-1)*TB_S(-1) + C(29)*TOT_SA_S(-2)*TB_S(-2) + C(30)*TOT_SA_S(-3)*TB_S(-3) + C(31)*TOT_SA_S(-4)*TB_S(-4) + C(32)*TOT_SA_S(-5)*TB_S(-5) + C(33)*TOT_SA_S(-6)*TB_S(-6) + C(34)*TOT_SA_S(-7)*TB_S(-7) + C(35)*TOT_SA_S(-8)*TB_S(-8) + C(36)*TOT_SA_S(-9)*TB_S(-9) + C(37)*TOT_SA_S(-10)*TB_S(-10) + C(38)*TOT_SA_S(-11)*TB_S(-11) + C(39)*TOT_SA_S(-12)*TB_S(-12) + C(40)*TOT_SA1_S*TB_S + C(41)*TOT_SA2_S*TB_S + C(42)*TOT_SA3_S*TB_S + C(43)*TOT_SA4_S*TB_S + C(44)*TOT_SA5_S*TB_S + C(45)*TOT_SA6_S*TB_S + C(46)*TOT_SA_S*GB_S + C(47)*TOT_SA_S(-1)*GB_S(-1) + C(48)*TOT_SA_S(-2)*GB_S(-2) + C(49)*TOT_SA_S(-3)*GB_S(-3) + C(50)*TOT_SA_S(-4)*GB_S(-4) + C(51)*TOT_SA_S(-5)*GB_S(-5) + C(52)*TOT_SA_S(-6)*GB_S(-6) + C(53)*TOT_SA_S(-7)*GB_S(-7) + C(54)*TOT_SA_S(-8)*GB_S(-8) + C(55)*TOT_SA_S(-9)*GB_S(-9) + C(56)*TOT_SA_S(-10)*GB_S(-10) + C(57)*TOT_SA_S(-11)*GB_S(-11) + C(58)*TOT_SA_S(-12)*GB_S(-12)+ C(59)*TOT_SA1_S*GB_S + C(60)*TOT_SA2_S*GB_S + C(61)*TOT_SA3_S*GB_S + C(62)*TOT_SA4_S*GB_S + C(63)*TOT_SA5_S*GB_S + C(64)*TOT_SA6_S*GB_S + C(65) '   + C(66)*ser_{%V}(-1)

	'{%sys}.append ser_{%V}  =  C(1)*TOT_SU_S*TB_S + C(2)*TOT_SU_S(-1)*TB_S(-1) + C(3)*TOT_SU_S(-2)*TB_S(-2) + C(4)*TOT_SU_S(-3)*TB_S(-3) + C(5)*TOT_SU_S(-4)*TB_S(-4) + C(6)*TOT_SU_S(-5)*TB_S(-5) + C(7)*TOT_SU_S(-6)*TB_S(-6) +  C(8)*TOT_SU_S(-7)*TB_S(-7) + C(9)*TOT_SU_S(-8)*TB_S(-8) + C(14)*TOT_SU_S*GB_S + C(15)*TOT_SU_S(-1)*GB_S(-1) + C(16)*TOT_SU_S(-2)*GB_S(-2) + C(17)*TOT_SU_S(-3)*GB_S(-3) + C(18)*TOT_SU_S(-4)*GB_S(-4) + C(19)*TOT_SU_S(-5)*GB_S(-5) + C(20)*TOT_SU_S(-6)*GB_S(-6) + C(21)*TOT_SU_S(-7)*GB_S(-7) + C(22)*TOT_SU_S(-8)*GB_S(-8) + C(27)*TOT_SA_S*TB_S + C(28)*TOT_SA_S(-1)*TB_S(-1) + C(29)*TOT_SA_S(-2)*TB_S(-2) + C(30)*TOT_SA_S(-3)*TB_S(-3) + C(31)*TOT_SA_S(-4)*TB_S(-4) + C(32)*TOT_SA_S(-5)*TB_S(-5) + C(33)*TOT_SA_S(-6)*TB_S(-6) + C(34)*TOT_SA_S(-7)*TB_S(-7) + C(35)*TOT_SA_S(-8)*TB_S(-8) + C(40)*TOT_SA1_S*TB_S + C(41)*TOT_SA2_S*TB_S + C(42)*TOT_SA3_S*TB_S + C(43)*TOT_SA4_S*TB_S + C(44)*TOT_SA5_S*TB_S + C(45)*TOT_SA6_S*TB_S + C(46)*TOT_SA_S*GB_S + C(47)*TOT_SA_S(-1)*GB_S(-1) + C(48)*TOT_SA_S(-2)*GB_S(-2) + C(49)*TOT_SA_S(-3)*GB_S(-3) + C(50)*TOT_SA_S(-4)*GB_S(-4) + C(51)*TOT_SA_S(-5)*GB_S(-5) + C(52)*TOT_SA_S(-6)*GB_S(-6) + C(53)*TOT_SA_S(-7)*GB_S(-7) + C(54)*TOT_SA_S(-8)*GB_S(-8) + C(59)*TOT_SA1_S*GB_S + C(60)*TOT_SA2_S*GB_S + C(61)*TOT_SA3_S*GB_S + C(62)*TOT_SA4_S*GB_S + C(63)*TOT_SA5_S*GB_S + C(64)*TOT_SA6_S*GB_S + C(65) '   + C(66)*ser_{%V}(-1)
	
	system {%sys1}
'uncomment if you have intercept
	FOR !i = 1 TO !horz
		{%sys1}.append TOT_SA{!i}_S*TB_S = CS_TB(!i) + CS_TB(!i+50)*TOT_SU_S*TB_S
	NEXT
	FOR !i = 1 TO !horz
		{%sys1}.append TOT_SA{!i}_S*GB_S = CS_GB(!i) + CS_GB(!i+50)*TOT_SU_S*GB_S
	NEXT
'uncomment if there is no intercept and you do not allow for heterogeneity of the style depending on TB and EB plans
	'FOR !i = 1 TO !horz
	'	{%sys}.append TOT_SA{!i}_S = CS(!i+50)*TOT_SU_S
	'NEXT

	smpl %startdate  %enddate
	{%sys}.sur 
	{%sys1}.sur 
	vector V_coef_sys={%sys1}.@coefs


	'IF %startdate = "1990q1" THEN
	'	range 1990q1 2020q4
	'else 
	'	range 1975q1 2020q4
	'ENDIF
	
	{%sys}.makemodel(VARMOD)
	'FOR %V {%VAR} 
  			VARMOD.addassign ser_{%V}
	'NEXT
	
	delete resid1* resid2* resid3* resid4* resid6* resid7* resid8* resid9* resid0*
	
	{%sys}.makeresids(n=gr_res)
	
	FOR !i = 1 TO !m
			series resid{!i}=resid0{!i}
			delete resid0{!i}
	NEXT
	
	scalar temp_res = 0
	
	'FOR %V {%VAR} 
			temp_res = temp_res + 1
			!p = temp_res
			genr res_{%V} = resid{!p}
	'NEXT
	delete temp_res* 
	
	'*************************************************************************************************
  	'*    BOOTSTRAP     *
	'*************************************************************************************************
	FOR !j=1 TO !reps
		smpl %startdate  %enddate
		delete gr_res*
		group gr_res
		'FOR %V {%VAR} 
			gr_res.add res_{%V}
		'next 
		'gr_res.resample(dropna)
		gr_res.resample(block = 2, dropna)
	
		'FOR %V {%VAR}
			series ser_{%V}_a = res_{%V}_b
			delete res_{%V}_b
		'NEXT
		
		
		'			FOR %V {%VAR}  
		'					res_{%V}.resample(dropna) ser_{%V}_a
		'			NEXT
	
		VARMOD.stochastic(i=b, d=t, v=t, r=100, s=%startdate+1 %enddate, f=.1, b=.83,c=f)
		VARMOD.solveopt(s=m)
		smpl %startdate  %enddate 
		VARMOD.solve
		smpl %startdate  %enddate
	
	delete {%sys2}* 
	system {%sys2} 
	
	{%sys2}.append ser_{%V}_0m  =  C2(1) + C2(2)*TOT_SU_S*TB_S + C2(3)*TOT_SU_S(-1)*TB_S(-1) + C2(4)*TOT_SU_S(-2)*TB_S(-2) + C2(5)*TOT_SU_S(-3)*TB_S(-3) + C2(6)*TOT_SU_S(-4)*TB_S(-4) + C2(7)*TOT_SU_S(-5)*TB_S(-5) + C2(8)*TOT_SU_S(-6)*TB_S(-6) + C2(10)*TOT_SU_S*GB_S + C2(11)*TOT_SU_S(-1)*GB_S(-1) + C2(12)*TOT_SU_S(-2)*GB_S(-2) + C2(13)*TOT_SU_S(-3)*GB_S(-3) + C2(14)*TOT_SU_S(-4)*GB_S(-4) + C2(15)*TOT_SU_S(-5)*GB_S(-5) + C2(16)*TOT_SU_S(-6)*GB_S(-6) + C2(18)*TOT_SA_S*TB_S + C2(19)*TOT_SA_S(-1)*TB_S(-1) + C2(20)*TOT_SA_S(-2)*TB_S(-2) + C2(21)*TOT_SA_S(-3)*TB_S(-3) + C2(22)*TOT_SA_S(-4)*TB_S(-4) + C2(23)*TOT_SA_S(-5)*TB_S(-5) + C2(24)*TOT_SA_S(-6)*TB_S(-6) + C2(26)*TOT_SA1_S*TB_S + C2(27)*TOT_SA2_S*TB_S + C2(28)*TOT_SA3_S*TB_S + C2(29)*TOT_SA4_S*TB_S + C2(30)*TOT_SA5_S*TB_S + C2(31)*TOT_SA6_S*TB_S + C2(34)*TOT_SA_S*GB_S + C2(35)*TOT_SA_S(-1)*GB_S(-1) + C2(36)*TOT_SA_S(-2)*GB_S(-2) + C2(37)*TOT_SA_S(-3)*GB_S(-3) + C2(38)*TOT_SA_S(-4)*GB_S(-4) + C2(39)*TOT_SA_S(-5)*GB_S(-5) + C2(40)*TOT_SA_S(-6)*GB_S(-6) + C2(42)*TOT_SA1_S*GB_S + C2(43)*TOT_SA2_S*GB_S + C2(44)*TOT_SA3_S*GB_S + C2(45)*TOT_SA4_S*GB_S + C2(46)*TOT_SA5_S*GB_S + C2(47)*TOT_SA6_S*GB_S 
	
	'{%sys2}.append ser_{%V}_0m  =  C2(1)*TOT_SU_S*TB_S + C2(2)*TOT_SU_S(-1)*TB_S(-1) + C2(3)*TOT_SU_S(-2)*TB_S(-2) + C2(4)*TOT_SU_S(-3)*TB_S(-3) + C2(5)*TOT_SU_S(-4)*TB_S(-4) + C2(6)*TOT_SU_S(-5)*TB_S(-5) + C2(7)*TOT_SU_S(-6)*TB_S(-6) +  C2(8)*TOT_SU_S(-7)*TB_S(-7) + C2(9)*TOT_SU_S(-8)*TB_S(-8) + C2(10)*TOT_SU_S(-9)*TB_S(-9) + C2(11)*TOT_SU_S(-10)*TB_S(-10) + C2(12)*TOT_SU_S(-11)*TB_S(-11) + C2(13)*TOT_SU_S(-12)*TB_S(-12) + C2(14)*TOT_SU_S*GB_S + C2(15)*TOT_SU_S(-1)*GB_S(-1) + C2(16)*TOT_SU_S(-2)*GB_S(-2) + C2(17)*TOT_SU_S(-3)*GB_S(-3) + C2(18)*TOT_SU_S(-4)*GB_S(-4) + C2(19)*TOT_SU_S(-5)*GB_S(-5) + C2(20)*TOT_SU_S(-6)*GB_S(-6) + C2(21)*TOT_SU_S(-7)*GB_S(-7) + C2(22)*TOT_SU_S(-8)*GB_S(-8) + C2(23)*TOT_SU_S(-9)*GB_S(-9) + C2(24)*TOT_SU_S(-10)*GB_S(-10) + C2(25)*TOT_SU_S(-11)*GB_S(-11) + C2(26)*TOT_SU_S(-12)*GB_S(-12) + C2(27)*TOT_SA_S*TB_S + C2(28)*TOT_SA_S(-1)*TB_S(-1) + C2(29)*TOT_SA_S(-2)*TB_S(-2) + C2(30)*TOT_SA_S(-3)*TB_S(-3) + C2(31)*TOT_SA_S(-4)*TB_S(-4) + C2(32)*TOT_SA_S(-5)*TB_S(-5) + C2(33)*TOT_SA_S(-6)*TB_S(-6) + C2(34)*TOT_SA_S(-7)*TB_S(-7) + C2(35)*TOT_SA_S(-8)*TB_S(-8) + C2(36)*TOT_SA_S(-9)*TB_S(-9) + C2(37)*TOT_SA_S(-10)*TB_S(-10) + C2(38)*TOT_SA_S(-11)*TB_S(-11) + C2(39)*TOT_SA_S(-12)*TB_S(-12) + C2(40)*TOT_SA1_S*TB_S + C2(41)*TOT_SA2_S*TB_S + C2(42)*TOT_SA3_S*TB_S + C2(43)*TOT_SA4_S*TB_S + C2(44)*TOT_SA5_S*TB_S + C2(45)*TOT_SA6_S*TB_S + C2(46)*TOT_SA_S*GB_S + C2(47)*TOT_SA_S(-1)*GB_S(-1) + C2(48)*TOT_SA_S(-2)*GB_S(-2) + C2(49)*TOT_SA_S(-3)*GB_S(-3) + C2(50)*TOT_SA_S(-4)*GB_S(-4) + C2(51)*TOT_SA_S(-5)*GB_S(-5) + C2(52)*TOT_SA_S(-6)*GB_S(-6) + C2(53)*TOT_SA_S(-7)*GB_S(-7) + C2(54)*TOT_SA_S(-8)*GB_S(-8) + C2(55)*TOT_SA_S(-9)*GB_S(-9) + C2(56)*TOT_SA_S(-10)*GB_S(-10) + C2(57)*TOT_SA_S(-11)*GB_S(-11) + C2(58)*TOT_SA_S(-12)*GB_S(-12)+ C2(59)*TOT_SA1_S*GB_S + C2(60)*TOT_SA2_S*GB_S + C2(61)*TOT_SA3_S*GB_S + C2(62)*TOT_SA4_S*GB_S + C2(63)*TOT_SA5_S*GB_S + C2(64)*TOT_SA6_S*GB_S + C2(65) '   + C2(66)*ser_{%V}_0m(-1)

	'{%sys2}.append ser_{%V}_0m  =  C2(1)*TOT_SU_S*TB_S + C2(2)*TOT_SU_S(-1)*TB_S(-1) + C2(3)*TOT_SU_S(-2)*TB_S(-2) + C2(4)*TOT_SU_S(-3)*TB_S(-3) + C2(5)*TOT_SU_S(-4)*TB_S(-4) + C2(6)*TOT_SU_S(-5)*TB_S(-5) + C2(7)*TOT_SU_S(-6)*TB_S(-6) +  C2(8)*TOT_SU_S(-7)*TB_S(-7) + C2(9)*TOT_SU_S(-8)*TB_S(-8) + C2(14)*TOT_SU_S*GB_S + C2(15)*TOT_SU_S(-1)*GB_S(-1) + C2(16)*TOT_SU_S(-2)*GB_S(-2) + C2(17)*TOT_SU_S(-3)*GB_S(-3) + C2(18)*TOT_SU_S(-4)*GB_S(-4) + C2(19)*TOT_SU_S(-5)*GB_S(-5) + C2(20)*TOT_SU_S(-6)*GB_S(-6) + C2(21)*TOT_SU_S(-7)*GB_S(-7) + C2(22)*TOT_SU_S(-8)*GB_S(-8) + C2(27)*TOT_SA_S*TB_S + C2(28)*TOT_SA_S(-1)*TB_S(-1) + C2(29)*TOT_SA_S(-2)*TB_S(-2) + C2(30)*TOT_SA_S(-3)*TB_S(-3) + C2(31)*TOT_SA_S(-4)*TB_S(-4) + C2(32)*TOT_SA_S(-5)*TB_S(-5) + C2(33)*TOT_SA_S(-6)*TB_S(-6) + C2(34)*TOT_SA_S(-7)*TB_S(-7) + C2(35)*TOT_SA_S(-8)*TB_S(-8) + C2(40)*TOT_SA1_S*TB_S + C2(41)*TOT_SA2_S*TB_S + C2(42)*TOT_SA3_S*TB_S + C2(43)*TOT_SA4_S*TB_S + C2(44)*TOT_SA5_S*TB_S + C2(45)*TOT_SA6_S*TB_S + C2(46)*TOT_SA_S*GB_S + C2(47)*TOT_SA_S(-1)*GB_S(-1) + C2(48)*TOT_SA_S(-2)*GB_S(-2) + C2(49)*TOT_SA_S(-3)*GB_S(-3) + C2(50)*TOT_SA_S(-4)*GB_S(-4) + C2(51)*TOT_SA_S(-5)*GB_S(-5) + C2(52)*TOT_SA_S(-6)*GB_S(-6) + C2(53)*TOT_SA_S(-7)*GB_S(-7) + C2(54)*TOT_SA_S(-8)*GB_S(-8) + C2(59)*TOT_SA1_S*GB_S + C2(60)*TOT_SA2_S*GB_S + C2(61)*TOT_SA3_S*GB_S + C2(62)*TOT_SA4_S*GB_S + C2(63)*TOT_SA5_S*GB_S + C2(64)*TOT_SA6_S*GB_S + C2(65) '   + C2(66)*ser_{%V}_0m(-1)

	'FOR !i = 1 TO !horz
	'	{%sys2}.append TOT_SA{!i}_S_0m = CS2(!i) + CS2(!i+50)*TOT_SU_S
	'NEXT

	 	{%sys2}.sur
	
			SMPL @ALL
			'***** SCENARIO
			{%sys2}.makemodel(VARMOD_2)
			VARMOD_2.append assign @all  _ALT
			VARMOD_2.scenario(n, a=_{%K}) "Alternative"_{%K}
			VARMOD_2.scenario "Alternative"_{%K}

	'CREATING SERIES FOR SHOCKS AND CONSTRUCTING SHOCKS DEPENDING ON SCENARIO
		SMPL @ALL
				genr TOT_SU_S_{%K} = TOT_SU_S
				FOR !t = 1 to !horz
						genr TOT_SA{!t}_S_{%K} = TOT_SA{!t}_S
				NEXT
				genr TOT_SA_S_{%K} = TOT_SA_S
				genr TB_S_{%K} = TB_S
				genr GB_S_{%K} = GB_S
			
	
		smpl %enddate+1 %enddate+!horz_irf+!horz
		
					TOT_SU_S_{%K} = 0				
					TOT_SU_S = 0
					FOR !t = 1 to !horz
						TOT_SA{!t}_S_{%K} = 0
						TOT_SA{!t}_S = 0
					NEXT
					TOT_SA_S_{%K} = 0
					TOT_SA_S = 0
				IF %K = "t" THEN
					TB_S_{%K} = 1
					GB_S_{%K} = 0   
				ELSE    
					GB_S_{%K} = 1
					TB_S_{%K} = 0
				ENDIF
				TB_S = 0
				GB_S = 0
	
	'THIS IS THE INITIALIZATION OF THE PLAN
		smpl %enddate+1 %enddate+1
		
			IF %K = "t" THEN
				TOT_SU_S_{%K} = 0.58    '1    0.25   0.77 
		scalar TOT_plan_{%K}_cum = @first(TOT_SU_S_{%K})      '  TOT_plan_{%K}_cum -  TOTAL value of the plan
				'!k = {%sys}.@eqncoef(1)     '  this command gives # of coeff in the equation (1)
					' uncomment if there is intercept
				!k = 0
				FOR !i = 1 TO !horz
					!k = !k +2
					TOT_SA{!i}_S_{%K} = V_coef_sys(!k-1) + V_coef_sys(!k)*TOT_SU_S_{%K}
					' uncomment if there is no intercept
					'!k = !k +1
					'TOT_SA{!i}_S_{%K} = V_coef_sys(!k)*TOT_SU_S_{%K}
					TOT_plan_{%K}_cum = TOT_plan_{%K}_cum + @first(TOT_SA{!i}_S_{%K})
				NEXT
			ELSE  
				TOT_SU_S_{%K} = 0.79    '1    0.25   0.77
		scalar TOT_plan_{%K}_cum = @first(TOT_SU_S_{%K})      '  TOT_plan_{%K}_cum -  TOTAL value of the plan
				'!k = {%sys}.@eqncoef(1) + 2*!horz
				!k = 2*!horz
				FOR !i = 1 TO !horz
					!k = !k +2
					TOT_SA{!i}_S_{%K} = V_coef_sys(!k-1) + V_coef_sys(!k)*TOT_SU_S_{%K}
					TOT_plan_{%K}_cum = TOT_plan_{%K}_cum + @first(TOT_SA{!i}_S_{%K})
				NEXT
			ENDIF


	'THIS CYCLE SLIDES THE ANTICIPATED PART OF THE PLAN DOWN	
		FOR !t = 2 to !horz+1
			smpl %enddate+!t %enddate+!t
			'!tt = !t-1
			TOT_SA_S_{%K} = TOT_SA1_S_{%K}(-1) 
			!INC = !horz - !t +1
			FOR !p = 1 to !INC
				'!pp = !p + !t - 1
				!pp = !p + 1
				TOT_SA{!p}_S_{%K} = TOT_SA{!pp}_S_{%K}(-1)
			NEXT
		NEXT

	'THIS CYCLE USES SCENARIO FOR OVERRIDE DIFFERENT PLANS
		smpl %enddate+1 %enddate+!horz_irf

			VARMOD_2.scenario "Alternative"_{%K}
			VARMOD_2.override(m) TOT_SU_S
			FOR !t = 1 to !horz
				VARMOD_2.override(m) TOT_SA{!t}_S
			NEXT
			VARMOD_2.override(m) TOT_SA_S
			VARMOD_2.override(m) {%K}B_S
		
				
					VARMOD_2.scenario "Alternative"_{%K}		
					VARMOD_2.scenario(C) "Baseline"
					VARMOD_2.stochastic(i=b, d=t, v=t, r=100, s=%startdate+1 %enddate, f=.1, b=.83,c=f)
					VARMOD_2.solveopt(s=m,d=d, A=T)
					VARMOD_2.solve
			
	'for cumulated IR need uncomment 
				IF @wfind(%diff, %V)<>0 THEN
					smpl %enddate+1 %enddate+1
					genr ser_{%V}_0m_{%K}_ALTM_c = ser_{%V}_0m_{%K}_ALTM
					smpl %enddate+2 %enddate+!horz_irf
					series ser_{%V}_0m_{%K}_ALTM_c = ser_{%V}_0m_{%K}_ALTM_c(-1)+ser_{%V}_0m_{%K}_ALTM
				
					smpl %enddate+1 %enddate+!horz_irf
					stomNA( ser_{%V}_0m_{%K}_ALTM_c,temp) 'cumulated IRF
					colplace(M_{%V}_{%K} ,temp,!j)		
				ELSE  'usual IRF
					smpl %enddate+1 %enddate+!horz_irf
					stomNA(ser_{%V}_0m_{%K}_ALTM,temp) 
					colplace(M_{%V}_{%K} ,temp,!j)
				ENDIF		
	 			
NEXT

'****************************************************************************************************************
' 	END OF THE BOOTSTRAP		  *
'****************************************************************************************************************

	'find bootstrap percentiles
	'FOR %V {%VAR} 	
		delete vtmp*
		rowvector vtmp
		matrix(!horz_irf,3) M_IRF_{%V}_{%K}
		'matrix(!horz_irf,3) M_IRF_{%V}_{%K}_SC  ' scaled matrix

				FOR !i=1 TO !horz_irf
					vtmp = @rowextract(M_{%V}_{%K},!i)
					M_IRF_{%V}_{%K}(!i,1) = @quantile(vtmp,0.84) ' 0.975
					M_IRF_{%V}_{%K}(!i,2) = @quantile(vtmp,0.50)
					M_IRF_{%V}_{%K}(!i,3) = @quantile(vtmp,0.16) '0.025

					'M_IRF_{%V}_{%K}_SC(!i,1) = M_IRF_{%V}_{%K}(!i,1)/@abs(TOT_plan_{%K}_cum)
					'M_IRF_{%V}_{%K}_SC(!i,2) = M_IRF_{%V}_{%K}(!i,2)/@abs(TOT_plan_{%K}_cum)
					'M_IRF_{%V}_{%K}_SC(!i,3) = M_IRF_{%V}_{%K}(!i,3)/@abs(TOT_plan_{%K}_cum)
				NEXT
	'NEXT
		 
delete temp varmod* sys_bs_{%V}2 resid* res*     '  ser_d*
NEXT '(for loop %V)

next  '(for loop %K)
endsub
